.model tiny
.286

code segment
	assume cs:code,ds:code,es:code,ss:code
	org 100h

start:
.386
;gfx
 mov    al,13h
 int    10h

 push	0a000h			;set up segments
 pop	es

 push	06000h			;hope its freee...
 pop	ds

;gray pal
 xor ax,ax
 mov dx,03c8h
 out dx,al
 inc dx
l1: 
 mov al,bl
 shr al,2
 out dx,al
 out dx,al
 out dx,al
 inc bx
 jnz l1

;make bump map
@@make_surface:
	xor     ax,cx
	rol     al,cl
	xor     cx,ax
	mov     [bx],cl
	dec     bx
	jnz     @@make_surface

	mov     dx,6
@@smoothloop1:                          ; smooth out the bump map
	xor	si,si
 	mov     cx,-1
@@smoothloop2:
	lodsb
	mov	bl,[si-2]
	add	ax,bx
	mov	bl,[si+318]
	add	ax,bx
	mov	bl,[si+320]
	add	ax,bx
	shr	ax,2
	mov	[si-1],al
	loop    @@smoothloop2
	dec     dx
	jnz     @@smoothloop1

;do bump
keypressed:

 mov ax,3
 int 33h

 neg dx           ;dx = mousey
 neg cx           ;cx = mousex

 xor di,di        ;screen pos

 mov bp,200              ; y count
@@y:
  mov si,320             ; x count
  push cx
  @@x:
     mov al,[di-1]
     mov bl,[di+1]
     sub ax,bx
     sub ax,cx
     jns @@1
       neg ax
   @@1:

     mov bl,[di-320]
     mov bh,[di+320]
     sub bl,bh
     movsx bx,bl
     sub bx,dx
     jns @@2
       neg bx
   @@2:
     add ax,bx
     not al

     or ah,ah
     jz @@3
     xor ax,ax
@@3: stosb

     inc cx
   dec si
   jnz @@x
   pop cx
 inc dx
 dec bp
 jnz @@y

 in     al,60h
 dec    al
 jnz    keypressed

_exit:
 mov    al,03h
 int    10h
ret

code ends
end start
